<template>
  <div>
    <div class="top top--sticky">
      <div class="navbar-container">
        <div class="navbar">
          <nuxt-link :to="'/'">
            <div class="logo">
              <img
                src="~/assets/images/logo.png"
                alt=""
                srcset=""
                width="125px"
              />
            </div>
          </nuxt-link>
          <form
            class="search-form"
            action="/products"
            method="get"
            _lpchecked="1"
          >
            <div class="input-group">
              <div class="input-group-area">
                <input
                  type="text"
                  name="search"
                  v-model="search"
                  placeholder="Cari produk disini"
                />
              </div>
              <div class="input-group-icon">
                <input type="submit" class="input-group-icon" value="" />
              </div>
            </div>
          </form>

          <nav>
            <ul id="menuItems">
              <li><nuxt-link :to="'/products'">Produk</nuxt-link></li>
              <li><nuxt-link :to="'/about'">Tentang Kami</nuxt-link></li>
              <li><nuxt-link :to="'/contact'">Kontak</nuxt-link></li>
            </ul>
            <div class="cart-header">
              <div class="cart-wrapper">
                <img src="~/assets/images/cart.png" height="30px" />
                <span v-if="productCart.length > 0" class="total-cart">{{
                  productCart.length
                }}</span>
              </div>
            </div>
            <img
              src="~/assets/images/menu.png"
              class="menu-icon"
              @click="handleMenuToggle()"
            />
          </nav>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState } from "vuex";
export default {
  name: "AppToolbar",
  data() {
    return {
      search: ""
    };
  },
  computed: {
    ...mapState({
      productCart: state => state.products.productCart
    })
  },
  mounted() {
    let menuItems = document.getElementById("menuItems");
    menuItems.style.maxHeight = "0px";
  },
  methods: {
    handleSearchProduct() {
      this.$store.commit("products/SET_SEARCH_PRODUCT", this.search);
      this.$store.dispatch("products/fetch");
      this.$router.push("/products");
    },
    handleMenuToggle() {
      let menuItems = document.getElementById("menuItems");
      if (menuItems.style.maxHeight === "0px") {
        menuItems.style.maxHeight = "200px";
      } else {
        menuItems.style.maxHeight = "0px";
      }
    }
  },
  watch: {
    "$route.query": {
      handler(query) {
        if (query.search) {
          this.search = query.search;
        }
      },
      immediate: true
    },
    $route: function(value) {
      let menuItems = document.getElementById("menuItems");
      menuItems.style.maxHeight = "0px";
    }
  }
};
</script>

<style lang="scss" scoped>
.navbar-container {
  max-width: 1300px;
  margin: auto;
  padding-left: 25px;
  padding-right: 25px;
}

.navbar {
  display: flex;
  align-items: flex-start;
  justify-content: space-between;
  padding: 20px;
  min-width: 340px;
}
nav {
  display: flex;
  text-align: right;
  ul {
    display: inline-block;
    margin-right: 20px;
    li {
      display: inline-block;
      margin-right: 20px;
    }
  }
}

.menu-icon {
  width: 28px;
  margin-left: 20px;
  display: none;
}

.search-form {
  flex-basis: 40%;
  margin: auto 20px;
  border-radius: 18px;
}

.top--sticky {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  -webkit-transform: translateZ(0);
  transform: translateZ(0);
  z-index: 100;
}

.cart-header {
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  z-index: 2;
  height: 40px;
  margin: 0 0 0 12px;
}
.cart-wrapper {
  width: 100%;
  height: 100%;
  max-width: 30px;
  min-width: 30px;
  display: flex;
  align-items: center;
  justify-content: center;
  position: relative;
  -webkit-box-pack: center;
}
.total-cart {
  min-width: 20px;
  min-height: 20px;
  color: rgb(255, 255, 255);
  font-size: 10px;
  font-weight: 700;
  line-height: 1.6;
  text-align: center;
  background-color: rgb(239, 20, 74);
  border: 2px solid rgb(255, 255, 255);
  border-radius: 18px;
  position: absolute;
  top: 0px;
  right: 0px;
  padding: 0px 4px;
  transform: translate(30%, -8%);
}
.cart-icon {
  background-position: 0 0;
  width: 30px;
  height: 30px;
  background-image: url("~assets/images/cart.png");
  background-size: 100% auto;
  background-repeat: no-repeat;
}

.top {
  background: linear-gradient(-180deg, #ee9c9c, rgb(248, 224, 217));
  // background: radial-gradient(#fff, #ffd6d6);
  -webkit-transition: -webkit-transform 0.2s cubic-bezier(0.4, 0, 0.2, 1);
  transition: -webkit-transform 0.2s cubic-bezier(0.4, 0, 0.2, 1);
  transition: transform 0.2s cubic-bezier(0.4, 0, 0.2, 1);
  transition: transform 0.2s cubic-bezier(0.4, 0, 0.2, 1),
    -webkit-transform 0.2s cubic-bezier(0.4, 0, 0.2, 1);
  box-shadow: rgba(156, 3, 3, 0.07) 0px 4px 6px -1px;
}

.input-group button {
  height: 32px;
  width: 32px;
}

.menu-icon {
  display: inline-block;
  cursor: pointer;
}

@media only screen and (max-width: 470px) {
  .navbar .nuxt-link-active {
    display: none;
  }
}

@media only screen and (max-width: 800px) {
  nav ul {
    position: absolute;
    top: 70px;
    left: 0;
    background: #333;
    width: 100%;
    overflow: hidden;
    transition: max-height 0.5s;
    li {
      display: block;
      margin-right: 50px;
      margin-top: 10px;
      margin-bottom: 10px;
      a {
        color: white;
      }
    }
  }
}
</style>
